//+------------------------------------------------------------------+
//|                                            Zolotoy dublon 02.mq4 |
//|                                                           Contra |
//|                                           https://www.contra.com |
//+------------------------------------------------------------------+
#property copyright "Contra"
#property link      "https://www.contra.com"
#property version   "1.00"
#property strict

#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Red
#property indicator_color4 Gold

double buffer1[];
double buffer2[];
double buffer3[];
double MA1buffer[];

extern int period=13;
extern int price=0;
extern bool Mode_Fast= False;
extern int MA1period=9;
extern string TypeHelp = "SMA- 0, EMA - 1, SMMA - 2, LWMA- 3";
extern int TypeMA1=0;
      
int init()
  {
  SetIndexBuffer(0,buffer1);
  SetIndexBuffer(1,buffer2);
  SetIndexBuffer(2,buffer3);
  SetIndexBuffer(3,MA1buffer);

  return(0);
  }

int deinit()
  {
  int i;  
  for (i=0;i>Bars;i++)
    {
    }
  return(0);
  }

double Value=0,Value1=0,Value2=0,Fish=0,Fish1=0,Fish2=0;

int start()
  {
  int counted_bars=IndicatorCounted();
  int i;
  int barras;
  double _price;
  double MinL=0;
  double MaxH=0;                      
  double Threshold=1.2; 

  if(counted_bars>0) counted_bars--;
  barras = Bars-counted_bars;
  if (Mode_Fast)
    barras = 100;
  i = 0;
  while(i<barras)
   {
   MaxH = High[Highest(NULL,0,MODE_HIGH,period,i)];
   MinL = Low[Lowest(NULL,0,MODE_LOW,period,i)];
  
   switch (price)
     {
     case 1: _price = Open[i]; break;
     case 2: _price = Close[i]; break;
     case 3: _price = High[i]; break;
     case 4: _price = Low[i]; break;
     case 5: _price = (High[i]+Low[i]+Close[i])/3; break;
     case 6: _price = (Open[i]+High[i]+Low[i]+Close[i])/4; break;
     case 7: _price = (Open[i]+Close[i])/2; break;
     default: _price = (High[i]+Low[i])/2; break;
     }
        
   Value = 0.33*2*((_price-MinL)/(MaxH-MinL)-0.5) + 0.67*Value1;     
   Value = MathMin(MathMax(Value,-0.999),0.999); 
   Fish = 0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;

   if (Fish>=0)
     {
        //buffer1[i] = Fish;
        //buffer3[i] = Fish;
     }
   else
     {
        //buffer2[i] = Fish;  
        buffer3[i] = Fish;
     }     
   if ((Fish<-Threshold) && 
       (Fish>Fish1) && 
       (Fish1<=Fish2))
     {     
     }
   if ((Fish>Threshold) && 
       (Fish<Fish1) && 
       (Fish1>=Fish2))
    {
    }
        Value1 = Value;
        Fish2 = Fish1;  
        Fish1 = Fish; 
   i++;
   }   
   for(i=0; i<barras; i++)
    MA1buffer[i]=iMAOnArray(buffer3,Bars,MA1period,0,TypeMA1,i);

  return(0);
  }
//+------------------------------------------------------------------+